## mojoshader 0.0~hg1314%2Bdfsg

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.6)
PROJECT(MojoShader)

OPTION(BUILD_SHARED_LIBS "Build MojoShader as a shared library" OFF)
OPTION(PROFILE_D3D "Build MojoShader with support for the D3D profile" ON)
OPTION(PROFILE_BYTECODE "Build MojoShader with support for the BYTECODE profile" ON)
OPTION(PROFILE_HLSL "Build MojoShader with support for the HLSL profile" ON)
OPTION(PROFILE_GLSL120 "Build MojoShader with support for the GLSL120 profile" ON)
OPTION(PROFILE_GLSLES "Build MojoShader with support for the GLSLES profile" ON)
OPTION(PROFILE_GLSL "Build MojoShader with support for the GLSL profile" ON)
OPTION(PROFILE_ARB1 "Build MojoShader with support for the ARB1 profile" ON)
OPTION(PROFILE_ARB1_NV "Build MojoShader with support for the ARB1_NV profile" ON)
OPTION(PROFILE_METAL "Build MojoShader with support for the Metal profile" ON)
OPTION(PROFILE_SPIRV "Build MojoShader with support for the SPIR-V profile" ON)
OPTION(PROFILE_GLSPIRV "Build MojoShader with support for the ARB_gl_spirv profile" ON)
OPTION(EFFECT_SUPPORT "Build MojoShader with support for Effect framework files" ON)
OPTION(COMPILER_SUPPORT "Build MojoShader with support for HLSL source files" ON)
OPTION(FLIP_VIEWPORT "Build MojoShader with the ability to flip the GL viewport" OFF)
OPTION(DEPTH_CLIPPING "Build MojoShader with the ability to simulate [0, 1] depth clipping" OFF)
OPTION(XNA4_VERTEXTEXTURE "Build MojoShader with XNA4 vertex texturing behavior" OFF)

INCLUDE_DIRECTORIES(.)

# If Mercurial is installed and we are in a mercurial repository, include the rev# and changeset as version information.
FIND_PROGRAM(HG hg DOC "Path to hg command line app: http://www.selenic.com/mercurial/")
IF(NOT HG)
    MESSAGE(STATUS "Mercurial (hg) not found. You can go on, but version info will be wrong.")
    SET(MOJOSHADER_VERSION -1)
    SET(MOJOSHADER_CHANGESET "???")
ELSE(NOT HG)
    MARK_AS_ADVANCED(HG)

    # See if we are in an hg repository.
    EXECUTE_PROCESS(
        COMMAND hg root
        WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
        RESULT_VARIABLE HGVERSION_RC
        ERROR_QUIET
    )
    IF(NOT HGVERSION_RC EQUAL 0)
        MESSAGE(STATUS "Mercurial (hg) repository not found. You can go on, but version info will be wrong.")
        SET(MOJOSHADER_VERSION -1)
        SET(MOJOSHADER_CHANGESET "???")
    ELSE(NOT HGVERSION_RC EQUAL 0)
        # Query the rev and changeset.
        EXECUTE_PROCESS(
            COMMAND hg tip --template {rev}
            WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
            RESULT_VARIABLE HGVERSION_RC
            OUTPUT_VARIABLE MOJOSHADER_VERSION
            ERROR_QUIET
            OUTPUT_STRIP_TRAILING_WHITESPACE
        )
        EXECUTE_PROCESS(
            COMMAND hg tip --template hg-{rev}:{node|short}
            WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
            RESULT_VARIABLE HGVERSION_RC
            OUTPUT_VARIABLE MOJOSHADER_CHANGESET
            ERROR_QUIET
            OUTPUT_STRIP_TRAILING_WHITESPACE
        )
    ENDIF(NOT HGVERSION_RC EQUAL 0)
ENDIF(NOT HG)

WRITE_FILE(
    "${CMAKE_CURRENT_SOURCE_DIR}/mojoshader_version.h"
    "/* This file was autogenerated. Do not edit! */\n"
    "#ifndef _INCL_MOJOSHADER_VERSION_H_\n"
    "#define _INCL_MOJOSHADER_VERSION_H_\n"
    "#define MOJOSHADER_VERSION ${MOJOSHADER_VERSION}\n"
    "#define MOJOSHADER_CHANGESET \"${MOJOSHADER_CHANGESET}\"\n"
    "#endif\n"
)

IF(CMAKE_COMPILER_IS_GNUCC)
    ADD_DEFINITIONS(-Wall -ggdb3)
ENDIF(CMAKE_COMPILER_IS_GNUCC)

# testparse uses this when I'm looking at memory usage patterns.
#ADD_DEFINITIONS(-DMOJOSHADER_DEBUG_MALLOC=1)

IF(MSVC)
    ADD_DEFINITIONS(-D_CRT_SECURE_NO_WARNINGS=1)
    ADD_DEFINITIONS(-TP)  # force .c files to compile as C++.
ENDIF(MSVC)

# We build lemon, then use it to generate parser C code.
IF(COMPILER_SUPPORT)
    ADD_EXECUTABLE(lemon "misc/lemon.c")
    GET_TARGET_PROPERTY(LEMON lemon LOCATION)
    ADD_CUSTOM_COMMAND(
        OUTPUT "${CMAKE_CURRENT_SOURCE_DIR}/mojoshader_parser_hlsl.h"
        MAIN_DEPENDENCY "${CMAKE_CURRENT_SOURCE_DIR}/mojoshader_parser_hlsl.lemon"
        DEPENDS lemon "${CMAKE_CURRENT_SOURCE_DIR}/misc/lempar.c"
        COMMAND "${LEMON}"
        ARGS -q "-T${CMAKE_CURRENT_SOURCE_DIR}/misc/lempar.c" "${CMAKE_CURRENT_SOURCE_DIR}/mojoshader_parser_hlsl.lemon"
    )
ENDIF(COMPILER_SUPPORT)

IF(APPLE)
    IF(NOT IOS)
        find_library(CARBON_FRAMEWORK Carbon)  # Stupid Gestalt.
    ENDIF(NOT IOS)
ENDIF(APPLE)

IF(NOT PROFILE_D3D)
    ADD_DEFINITIONS(-DSUPPORT_PROFILE_D3D=0)
ENDIF(NOT PROFILE_D3D)
IF(NOT PROFILE_BYTECODE)
    ADD_DEFINITIONS(-DSUPPORT_PROFILE_BYTECODE=0)
ENDIF(NOT PROFILE_BYTECODE)
IF(NOT PROFILE_HLSL)
    ADD_DEFINITIONS(-DSUPPORT_PROFILE_HLSL=0)
ENDIF(NOT PROFILE_HLSL)
IF(NOT PROFILE_GLSL120)
    ADD_DEFINITIONS(-DSUPPORT_PROFILE_GLSL120=0)
ENDIF(NOT PROFILE_GLSL120)
IF(NOT PROFILE_GLSLES)
    ADD_DEFINITIONS(-DSUPPORT_PROFILE_GLSLES=0)
ENDIF(NOT PROFILE_GLSLES)
IF(NOT PROFILE_GLSL)
    ADD_DEFINITIONS(-DSUPPORT_PROFILE_GLSL=0)
ENDIF(NOT PROFILE_GLSL)
IF(NOT PROFILE_ARB1)
    ADD_DEFINITIONS(-DSUPPORT_PROFILE_ARB1=0)
ENDIF(NOT PROFILE_ARB1)
IF(NOT PROFILE_ARB1_NV)
    ADD_DEFINITIONS(-DSUPPORT_PROFILE_ARB1_NV=0)
ENDIF(NOT PROFILE_ARB1_NV)
IF(NOT PROFILE_METAL)
    ADD_DEFINITIONS(-DSUPPORT_PROFILE_METAL=0)
ELSE(NOT PROFILE_METAL)
    SET(LOBJC -lobjc)
ENDIF(NOT PROFILE_METAL)
IF(NOT PROFILE_SPIRV)
    ADD_DEFINITIONS(-DSUPPORT_PROFILE_SPIRV=0)
ENDIF(NOT PROFILE_SPIRV)
IF(NOT PROFILE_GLSPIRV)
    ADD_DEFINITIONS(-DSUPPORT_PROFILE_GLSPIRV=0)
ENDIF(NOT PROFILE_GLSPIRV)

IF(EFFECT_SUPPORT)
    IF(UNIX)
        SET(LIBM -lm)
    ENDIF(UNIX)
    ADD_DEFINITIONS(-DMOJOSHADER_EFFECT_SUPPORT)
ENDIF(EFFECT_SUPPORT)

IF(FLIP_VIEWPORT)
    ADD_DEFINITIONS(-DMOJOSHADER_FLIP_RENDERTARGET)
ENDIF(FLIP_VIEWPORT)

IF(DEPTH_CLIPPING)
    ADD_DEFINITIONS(-DMOJOSHADER_DEPTH_CLIPPING)
ENDIF(DEPTH_CLIPPING)

IF(XNA4_VERTEXTEXTURE)
    ADD_DEFINITIONS(-DMOJOSHADER_XNA4_VERTEX_TEXTURES)
ENDIF(XNA4_VERTEXTEXTURE)

ADD_LIBRARY(mojoshader
    mojoshader.c
    mojoshader_common.c
    mojoshader_opengl.c
    mojoshader_metal.c
    mojoshader_d3d11.c
    mojoshader_vulkan.c
    profiles/mojoshader_profile_arb1.c
    profiles/mojoshader_profile_bytecode.c
    profiles/mojoshader_profile_d3d.c
    profiles/mojoshader_profile_hlsl.c
    profiles/mojoshader_profile_glsl.c
    profiles/mojoshader_profile_metal.c
    profiles/mojoshader_profile_spirv.c
    profiles/mojoshader_profile_common.c
)
IF(EFFECT_SUPPORT)
    TARGET_SOURCES(mojoshader PRIVATE
        mojoshader_effects.c
    )
ENDIF(EFFECT_SUPPORT)
IF(COMPILER_SUPPORT)
    TARGET_SOURCES(mojoshader PRIVATE
        mojoshader_compiler.c
        mojoshader_preprocessor.c
        mojoshader_lexer.c
        mojoshader_assembler.c
    )
ENDIF(COMPILER_SUPPORT)
IF(BUILD_SHARED_LIBS)
    TARGET_LINK_LIBRARIES(mojoshader ${LIBM} ${LOBJC} ${CARBON_FRAMEWORK})
ENDIF(BUILD_SHARED_LIBS)

TARGET_INCLUDE_DIRECTORIES(mojoshader PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../Vulkan-Headers/include>
)

SET_SOURCE_FILES_PROPERTIES(
    mojoshader_compiler.c
    PROPERTIES OBJECT_DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/mojoshader_parser_hlsl.h"
)

FIND_PROGRAM(RE2C re2c DOC "Path to re2c command line app: http://re2c.org/")
IF(NOT RE2C)
    MESSAGE(STATUS "re2c missing. You can go on, but can't rebuild the lexer.")
ELSE(NOT RE2C)
    MARK_AS_ADVANCED(RE2C)
    ADD_CUSTOM_COMMAND(
        OUTPUT "${CMAKE_CURRENT_SOURCE_DIR}/mojoshader_lexer.c"
        DEPENDS mojoshader_lexer.re
        COMMAND "${RE2C}"
        ARGS -is --no-generation-date -o "${CMAKE_CURRENT_SOURCE_DIR}/mojoshader_lexer.c" "${CMAKE_CURRENT_SOURCE_DIR}/mojoshader_lexer.re"
    )
ENDIF(NOT RE2C)

find_path(SDL2_INCLUDE_DIR SDL.h PATH_SUFFIXES include/SDL2)
find_library(SDL2 NAMES SDL2 PATH_SUFFIXES lib)
IF(SDL2)
    INCLUDE_DIRECTORIES(${SDL2_INCLUDE_DIR})
    ADD_EXECUTABLE(glcaps utils/glcaps.c)
    TARGET_LINK_LIBRARIES(glcaps ${SDL2} ${LIBM} ${LOBJC} ${CARBON_FRAMEWORK})
    ADD_EXECUTABLE(bestprofile utils/bestprofile.c)
    TARGET_LINK_LIBRARIES(bestprofile mojoshader ${SDL2} ${LIBM} ${LOBJC} ${CARBON_FRAMEWORK})
    ADD_EXECUTABLE(availableprofiles utils/availableprofiles.c)
    TARGET_LINK_LIBRARIES(availableprofiles mojoshader ${SDL2} ${LIBM} ${LOBJC} ${CARBON_FRAMEWORK})
    ADD_EXECUTABLE(testglcompile utils/testglcompile.c)
    TARGET_LINK_LIBRARIES(testglcompile mojoshader ${SDL2} ${LIBM} ${LOBJC} ${CARBON_FRAMEWORK})
ENDIF(SDL2)

IF(COMPILER_SUPPORT)
    ADD_EXECUTABLE(finderrors utils/finderrors.c)
    TARGET_LINK_LIBRARIES(finderrors mojoshader ${SDL2} ${LIBM} ${LOBJC} ${CARBON_FRAMEWORK})
    IF(SDL2)
        SET_SOURCE_FILES_PROPERTIES(
            utils/finderrors.c
            PROPERTIES COMPILE_FLAGS "-DFINDERRORS_COMPILE_SHADERS=1"
        )
    ENDIF(SDL2)
ENDIF(COMPILER_SUPPORT)

FIND_PATH(SPIRV_TOOLS_INCLUDE_DIR "spirv-tools/libspirv.h" PATH_SUFFIXES "include")
FIND_LIBRARY(SPIRV_TOOLS_LIBRARY NAMES SPIRV-Tools-shared)
IF(SPIRV_TOOLS_INCLUDE_DIR AND SPIRV_TOOLS_LIBRARY)
    INCLUDE_DIRECTORIES(${SPIRV_TOOLS_INCLUDE_DIR})
    ADD_DEFINITIONS(-DMOJOSHADER_HAS_SPIRV_TOOLS)
ENDIF(SPIRV_TOOLS_INCLUDE_DIR AND SPIRV_TOOLS_LIBRARY)

ADD_EXECUTABLE(testparse utils/testparse.c)
TARGET_LINK_LIBRARIES(testparse mojoshader ${LIBM} ${LOBJC} ${CARBON_FRAMEWORK})
IF(SPIRV_TOOLS_INCLUDE_DIR AND SPIRV_TOOLS_LIBRARY)
    TARGET_LINK_LIBRARIES(testparse ${SPIRV_TOOLS_LIBRARY})
ENDIF(SPIRV_TOOLS_INCLUDE_DIR AND SPIRV_TOOLS_LIBRARY)
ADD_EXECUTABLE(testoutput utils/testoutput.c)
TARGET_LINK_LIBRARIES(testoutput mojoshader ${LIBM} ${LOBJC} ${CARBON_FRAMEWORK})
IF(COMPILER_SUPPORT)
    ADD_EXECUTABLE(mojoshader-compiler utils/mojoshader-compiler.c)
    TARGET_LINK_LIBRARIES(mojoshader-compiler mojoshader ${LIBM} ${LOBJC} ${CARBON_FRAMEWORK})
ENDIF(COMPILER_SUPPORT)

# Unit tests...
IF(COMPILER_SUPPORT)
    ADD_CUSTOM_TARGET(
        test
        COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/unit_tests/run_tests.pl"
        WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
        DEPENDS mojoshader-compiler
        COMMENT "Running unit tests..."
        VERBATIM
    )
ENDIF(COMPILER_SUPPORT)

# End of CMakeLists.txt ...

=== debian/changelog ===
mojoshader (0.0~hg1314+dfsg-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Source-only upload for testing migration. 

 -- Boyuan Yang <byang@debian.org>  Wed, 28 Oct 2020 10:30:51 -0400

mojoshader (0.0~hg1314+dfsg-1) unstable; urgency=medium

  * Initial Release (Closes: #972093)

 -- Yangfl <mmyangfl@gmail.com>  Sun, 18 Oct 2020 01:40:23 +0800

=== debian/control ===
Source: mojoshader
Section: libs
Priority: optional
Maintainer: Yangfl <mmyangfl@gmail.com>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 libgl-dev,
 libvulkan-dev,
 re2c,
 spirv-tools,
 libcryptx-perl,
Rules-Requires-Root: no
Standards-Version: 4.5.0
Homepage: https://icculus.org/mojoshader/
Vcs-Browser: https://salsa.debian.org/yangfl-guest/mojoshader
Vcs-Git: https://salsa.debian.org/yangfl-guest/mojoshader.git

Package: libmojoshader-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, libmojoshader0 (= ${binary:Version})
Description: library to move calls to Direct3D shaders to OpenGL (development files)
 MojoShader is a library to work with Direct3D shaders on alternate 3D APIs and
 non-Windows platforms. The primary motivation is moving shaders to OpenGL
 languages on the fly. The developer deals with "profiles" that represent
 various target languages, such as GLSL or ARB_*_program.
 .
 This allows a developer to manage one set of shaders, presumably written in
 Direct3D HLSL, and use them across multiple rendering backends. This also means
 that the developer only has to worry about one (offline) compiler to manage
 program complexity, while MojoShader itself deals with the reduced complexity
 of the bytecode at runtime.
 .
 MojoShader provides both a simple API to convert bytecode to various profiles,
 and (optionally) basic glue to rendering APIs to abstract the management of the
 shaders at runtime.
 .
 This package contains the header files and static library for libmojoshader0.

Package: libmojoshader0
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: library to move calls to Direct3D shaders to OpenGL
 MojoShader is a library to work with Direct3D shaders on alternate 3D APIs and
 non-Windows platforms. The primary motivation is moving shaders to OpenGL
 languages on the fly. The developer deals with "profiles" that represent
 various target languages, such as GLSL or ARB_*_program.
 .
 This allows a developer to manage one set of shaders, presumably written in
 Direct3D HLSL, and use them across multiple rendering backends. This also means
 that the developer only has to worry about one (offline) compiler to manage
 program complexity, while MojoShader itself deals with the reduced complexity
 of the bytecode at runtime.
 .
 MojoShader provides both a simple API to convert bytecode to various profiles,
 and (optionally) basic glue to rendering APIs to abstract the management of the
 shaders at runtime.

## mojoshader 0.0~hg1314+dfsg

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1


export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND =


%:
	dh $@

execute_after_dh_auto_clean:
	rm -f mojoshader_version.h mojoshader_parser_hlsl.h

override_dh_auto_configure:
	dh_auto_configure -- \
		-DMOJOSHADER_VERSION=1314 \
		-DMOJOSHADER_CHANGESET=hg-1314:3ddd9fca664f

=== debian/watch ===
version=4
opts="searchmode=plain,dversionmangle=s/\+(debian|dfsg|ds|deb)(\.\d+)?$//,repacksuffix=+dfsg,uversionmangle=s/^/0.0~hg/,downloadurlmangle=s%.*%nonexistant%" \
   https://hg.icculus.org/icculus/mojoshader/log \
   rev\s(\d+) debian uupdate

## mojoshader 0.0~hg1314+git20250606.93d9d45+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,66 +1,73 @@
-CMAKE_MINIMUM_REQUIRED(VERSION 2.6)
+CMAKE_MINIMUM_REQUIRED(VERSION 3.12.0)
 PROJECT(MojoShader)
+
+# !!! FIXME: can we lowercase this file, if nothing else?
+
+INCLUDE(CheckIncludeFile)
+CHECK_INCLUDE_FILE(d3d11.h HAS_D3D11_H)
 
 OPTION(BUILD_SHARED_LIBS "Build MojoShader as a shared library" OFF)
 OPTION(PROFILE_D3D "Build MojoShader with support for the D3D profile" ON)
 OPTION(PROFILE_BYTECODE "Build MojoShader with support for the BYTECODE profile" ON)
-OPTION(PROFILE_HLSL "Build MojoShader with support for the HLSL profile" ON)
+OPTION(PROFILE_HLSL "Build MojoShader with support for the HLSL profile" HAS_D3D11_H)
 OPTION(PROFILE_GLSL120 "Build MojoShader with support for the GLSL120 profile" ON)
 OPTION(PROFILE_GLSLES "Build MojoShader with support for the GLSLES profile" ON)
 OPTION(PROFILE_GLSL "Build MojoShader with support for the GLSL profile" ON)
 OPTION(PROFILE_ARB1 "Build MojoShader with support for the ARB1 profile" ON)
 OPTION(PROFILE_ARB1_NV "Build MojoShader with support for the ARB1_NV profile" ON)
-OPTION(PROFILE_METAL "Build MojoShader with support for the Metal profile" ON)
+OPTION(PROFILE_METAL "Build MojoShader with support for the Metal profile" APPLE)
 OPTION(PROFILE_SPIRV "Build MojoShader with support for the SPIR-V profile" ON)
 OPTION(PROFILE_GLSPIRV "Build MojoShader with support for the ARB_gl_spirv profile" ON)
 OPTION(EFFECT_SUPPORT "Build MojoShader with support for Effect framework files" ON)
-OPTION(COMPILER_SUPPORT "Build MojoShader with support for HLSL source files" ON)
+OPTION(COMPILER_SUPPORT "Build MojoShader with support for HLSL source files" !WIN32) # TODO: Fix lemon on Windows
 OPTION(FLIP_VIEWPORT "Build MojoShader with the ability to flip the GL viewport" OFF)
 OPTION(DEPTH_CLIPPING "Build MojoShader with the ability to simulate [0, 1] depth clipping" OFF)
 OPTION(XNA4_VERTEXTEXTURE "Build MojoShader with XNA4 vertex texturing behavior" OFF)
 
 INCLUDE_DIRECTORIES(.)
 
-# If Mercurial is installed and we are in a mercurial repository, include the rev# and changeset as version information.
-FIND_PROGRAM(HG hg DOC "Path to hg command line app: http://www.selenic.com/mercurial/")
-IF(NOT HG)
-    MESSAGE(STATUS "Mercurial (hg) not found. You can go on, but version info will be wrong.")
-    SET(MOJOSHADER_VERSION -1)
+# This was a Mercurial thing. In Git, it's always -1.
+SET(MOJOSHADER_VERSION -1)
+
+# If Git is installed and we are in a git repository, include the changeset as version information.
+FIND_PROGRAM(GIT git DOC "Path to git command line app: https://git-scm.com/")
+IF(NOT GIT)
+    MESSAGE(STATUS "Git not found. You can go on, but version info will be wrong.")
     SET(MOJOSHADER_CHANGESET "???")
-ELSE(NOT HG)
-    MARK_AS_ADVANCED(HG)
-
-    # See if we are in an hg repository.
+ELSE(NOT GIT)
+    MARK_AS_ADVANCED(GIT)
+
+    # !!! FIXME: this didn't actually use the GIT variable...
+
+    # See if we are in a git repository.
     EXECUTE_PROCESS(
-        COMMAND hg root
+        COMMAND git rev-parse --show-toplevel
         WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
-        RESULT_VARIABLE HGVERSION_RC
+        OUTPUT_VARIABLE MOJOSHADER_GIT_TOPLEVEL_DIR
+        RESULT_VARIABLE GITVERSION_RC
         ERROR_QUIET
-    )
-    IF(NOT HGVERSION_RC EQUAL 0)
-        MESSAGE(STATUS "Mercurial (hg) repository not found. You can go on, but version info will be wrong.")
-        SET(MOJOSHADER_VERSION -1)
+        OUTPUT_STRIP_TRAILING_WHITESPACE
+    )
+    IF(NOT GITVERSION_RC EQUAL 0)
+        MESSAGE(STATUS "Git repository not found. You can go on, but version info will be wrong.")
         SET(MOJOSHADER_CHANGESET "???")
-    ELSE(NOT HGVERSION_RC EQUAL 0)
-        # Query the rev and changeset.
+    ELSE(NOT GITVERSION_RC EQUAL 0)
+        # Query the changeset.
         EXECUTE_PROCESS(
-            COMMAND hg tip --template {rev}
+            COMMAND git rev-list HEAD~..
             WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
-            RESULT_VARIABLE HGVERSION_RC
-            OUTPUT_VARIABLE MOJOSHADER_VERSION
+            RESULT_VARIABLE GITVERSION_RC
+            OUTPUT_VARIABLE MOJOSHADER_GIT_CHANGESET
             ERROR_QUIET
             OUTPUT_STRIP_TRAILING_WHITESPACE
         )
-        EXECUTE_PROCESS(
-            COMMAND hg tip --template hg-{rev}:{node|short}
-            WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
-            RESULT_VARIABLE HGVERSION_RC
-            OUTPUT_VARIABLE MOJOSHADER_CHANGESET
-            ERROR_QUIET
-            OUTPUT_STRIP_TRAILING_WHITESPACE
-        )
-    ENDIF(NOT HGVERSION_RC EQUAL 0)
-ENDIF(NOT HG)
+        IF(NOT GITVERSION_RC EQUAL 0)
+            SET(MOJOSHADER_CHANGESET "???")
+        ELSE(NOT GITVERSION_RC EQUAL 0)
+            SET(MOJOSHADER_CHANGESET "git-${MOJOSHADER_GIT_CHANGESET}")
+        ENDIF(NOT GITVERSION_RC EQUAL 0)
+    ENDIF(NOT GITVERSION_RC EQUAL 0)
+ENDIF(NOT GIT)
 
 WRITE_FILE(
     "${CMAKE_CURRENT_SOURCE_DIR}/mojoshader_version.h"
@@ -87,12 +94,11 @@
 # We build lemon, then use it to generate parser C code.
 IF(COMPILER_SUPPORT)
     ADD_EXECUTABLE(lemon "misc/lemon.c")
-    GET_TARGET_PROPERTY(LEMON lemon LOCATION)
     ADD_CUSTOM_COMMAND(
         OUTPUT "${CMAKE_CURRENT_SOURCE_DIR}/mojoshader_parser_hlsl.h"
         MAIN_DEPENDENCY "${CMAKE_CURRENT_SOURCE_DIR}/mojoshader_parser_hlsl.lemon"
         DEPENDS lemon "${CMAKE_CURRENT_SOURCE_DIR}/misc/lempar.c"
-        COMMAND "${LEMON}"
+        COMMAND lemon
         ARGS -q "-T${CMAKE_CURRENT_SOURCE_DIR}/misc/lempar.c" "${CMAKE_CURRENT_SOURCE_DIR}/mojoshader_parser_hlsl.lemon"
     )
 ENDIF(COMPILER_SUPPORT)
@@ -118,6 +124,9 @@
 IF(NOT PROFILE_GLSLES)
     ADD_DEFINITIONS(-DSUPPORT_PROFILE_GLSLES=0)
 ENDIF(NOT PROFILE_GLSLES)
+IF(NOT PROFILE_GLSLES3)
+    ADD_DEFINITIONS(-DSUPPORT_PROFILE_GLSLES3=0)
+ENDIF(NOT PROFILE_GLSLES3)
 IF(NOT PROFILE_GLSL)
     ADD_DEFINITIONS(-DSUPPORT_PROFILE_GLSL=0)
 ENDIF(NOT PROFILE_GLSL)
@@ -162,9 +171,8 @@
     mojoshader.c
     mojoshader_common.c
     mojoshader_opengl.c
-    mojoshader_metal.c
     mojoshader_d3d11.c
-    mojoshader_vulkan.c
+    mojoshader_sdlgpu.c
     profiles/mojoshader_profile_arb1.c
     profiles/mojoshader_profile_bytecode.c
     profiles/mojoshader_profile_d3d.c
@@ -191,8 +199,11 @@
     TARGET_LINK_LIBRARIES(mojoshader ${LIBM} ${LOBJC} ${CARBON_FRAMEWORK})
 ENDIF(BUILD_SHARED_LIBS)
 
+# These are fallback paths for D3D11, try to have this on the system instead!
 TARGET_INCLUDE_DIRECTORIES(mojoshader PUBLIC
-    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../Vulkan-Headers/include>
+    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../dxvk-native/include/native/directx>
+    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../dxvk-native/include/native/windows>
+    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../dxvk-native/include/native/wsi>
 )
 
 SET_SOURCE_FILES_PROPERTIES(
@@ -213,29 +224,30 @@
     )
 ENDIF(NOT RE2C)
 
-find_path(SDL2_INCLUDE_DIR SDL.h PATH_SUFFIXES include/SDL2)
-find_library(SDL2 NAMES SDL2 PATH_SUFFIXES lib)
-IF(SDL2)
-    INCLUDE_DIRECTORIES(${SDL2_INCLUDE_DIR})
+find_package(SDL2)
+IF(SDL2_FOUND)
+    INCLUDE_DIRECTORIES(${SDL2_INCLUDE_DIRS})
     ADD_EXECUTABLE(glcaps utils/glcaps.c)
-    TARGET_LINK_LIBRARIES(glcaps ${SDL2} ${LIBM} ${LOBJC} ${CARBON_FRAMEWORK})
+    TARGET_LINK_LIBRARIES(glcaps ${SDL2_LIBRARIES} ${LIBM} ${LOBJC} ${CARBON_FRAMEWORK})
     ADD_EXECUTABLE(bestprofile utils/bestprofile.c)
-    TARGET_LINK_LIBRARIES(bestprofile mojoshader ${SDL2} ${LIBM} ${LOBJC} ${CARBON_FRAMEWORK})
+    TARGET_LINK_LIBRARIES(bestprofile mojoshader ${SDL2_LIBRARIES} ${LIBM} ${LOBJC} ${CARBON_FRAMEWORK})
     ADD_EXECUTABLE(availableprofiles utils/availableprofiles.c)
-    TARGET_LINK_LIBRARIES(availableprofiles mojoshader ${SDL2} ${LIBM} ${LOBJC} ${CARBON_FRAMEWORK})
+    TARGET_LINK_LIBRARIES(availableprofiles mojoshader ${SDL2_LIBRARIES} ${LIBM} ${LOBJC} ${CARBON_FRAMEWORK})
     ADD_EXECUTABLE(testglcompile utils/testglcompile.c)
-    TARGET_LINK_LIBRARIES(testglcompile mojoshader ${SDL2} ${LIBM} ${LOBJC} ${CARBON_FRAMEWORK})
-ENDIF(SDL2)
+    TARGET_LINK_LIBRARIES(testglcompile mojoshader ${SDL2_LIBRARIES} ${LIBM} ${LOBJC} ${CARBON_FRAMEWORK})
+ENDIF(SDL2_FOUND)
 
 IF(COMPILER_SUPPORT)
     ADD_EXECUTABLE(finderrors utils/finderrors.c)
-    TARGET_LINK_LIBRARIES(finderrors mojoshader ${SDL2} ${LIBM} ${LOBJC} ${CARBON_FRAMEWORK})
-    IF(SDL2)
+    IF(SDL2_FOUND)
+        TARGET_LINK_LIBRARIES(finderrors mojoshader ${SDL2_LIBRARIES} ${LIBM} ${LOBJC} ${CARBON_FRAMEWORK})
         SET_SOURCE_FILES_PROPERTIES(
             utils/finderrors.c
             PROPERTIES COMPILE_FLAGS "-DFINDERRORS_COMPILE_SHADERS=1"
         )
-    ENDIF(SDL2)
+    ELSE(SDL2_FOUND)
+        TARGET_LINK_LIBRARIES(finderrors mojoshader ${LIBM} ${LOBJC} ${CARBON_FRAMEWORK})
+    ENDIF(SDL2_FOUND)
 ENDIF(COMPILER_SUPPORT)
 
 FIND_PATH(SPIRV_TOOLS_INCLUDE_DIR "spirv-tools/libspirv.h" PATH_SUFFIXES "include")

=== debian/changelog ===
mojoshader (0.0~hg1314+git20250606.93d9d45+dfsg-1) unstable; urgency=medium

  * New upstream snapshot
    * Fix FTBFS on architectures where char is unsigned
      (Closes: #976553)
    * Require libsdl2-dev (Closes: #991343)
    * Fix FTBFS with GCC-15 (Closes: #1097408)
    * Fix FTBFS with CMake 4 (Closes: #1113292)
  * Bump Standards-Version to 4.7.2

 -- Yangfl <mmyangfl@gmail.com>  Sat, 06 Sep 2025 23:47:24 +0800

=== debian/control ===
--- 
+++ 
@@ -6,12 +6,13 @@
  debhelper-compat (= 13),
  cmake,
  libgl-dev,
+ libsdl2-dev,
  libvulkan-dev,
  re2c,
  spirv-tools,
  libcryptx-perl,
 Rules-Requires-Root: no
-Standards-Version: 4.5.0
+Standards-Version: 4.7.2
 Homepage: https://icculus.org/mojoshader/
 Vcs-Browser: https://salsa.debian.org/yangfl-guest/mojoshader
 Vcs-Git: https://salsa.debian.org/yangfl-guest/mojoshader.git
@@ -41,6 +42,7 @@
 
 Package: libmojoshader0
 Architecture: any
+Multi-Arch: same
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: library to move calls to Direct3D shaders to OpenGL
  MojoShader is a library to work with Direct3D shaders on alternate 3D APIs and

=== debian/rules ===
--- 
+++ 
@@ -16,5 +16,5 @@
 
 override_dh_auto_configure:
 	dh_auto_configure -- \
-		-DMOJOSHADER_VERSION=1314 \
-		-DMOJOSHADER_CHANGESET=hg-1314:3ddd9fca664f
+		-DMOJOSHADER_CHANGESET=git-93d9d45e6d645150195ea1a74a1654e4a1542c52 \
+		-DCOMPILER_SUPPORT=ON

=== debian/watch ===
Version: 5
Source: https://github.com/icculus/mojoshader
Matching-Pattern: HEAD
Mode: git
Git-Pretty: 0.0~hg1314+git%cd.%h
Dversion-Mangle: s/\+dfsg\d*$//
Repacksuffix: +dfsg
